package visualization;

import java.awt.event.ActionListener;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Hashtable;

import javax.swing.JScrollPane;

import exceptions.VisualizationException;
import executionEngine.ASTReceive;
import executionEngine.ASTSend;
import executionEngine.ASTTau;

/**
 * Interface hiding the specialized visualizer for Pi-systems
 * @author Anja
 *
 */
public interface VisualizerInterface {
	public void addActionListener(ActionListener listener);
	
	public void removeActionListener(ActionListener listener);
	
	public JScrollPane createVisualOutput(ArrayList tauNodes,
			ArrayList commNodes, ArrayList allProcesses,
			ArrayList blockedNodes, Hashtable scope, boolean scaleToFit)
			throws FileNotFoundException, VisualizationException;
	
	public void clearSelection();
	
	public ASTReceive getCurrentlySelectedReceiveNode();
	
	public ASTSend getCurrentlySelectedSendNode();
	
	public ASTTau getCurrentlySelectedTauNode();
	
	public void updateAfterAgentImport();
}
